//-- Copyright (C) 2009 SES Lab and PAC Lab @VT
//--
//-- This program is free software; you can redistribute it and/or
//-- modify it under the terms of the GNU General Public License as
//-- published by the Free Software Foundation; either version 2 of the
//-- License, or (at your option) any later version.
//--
//-- This program is distributed in the hope that it will be useful,
//-- but WITHOUT ANY WARRANTY; without even the implied warranty of
//-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//-- GNU General Public License for more details.
//-------------------------------------------------------------------------------
//-- Title      : Butterfly module
//-- Project    : SHA3
//-------------------------------------------------------------------------------
//-- File       : butterfly2r.v
//-- Author     : Sinan Huang, Eric Guo
//-- Company    : PAC & SES @VT
//-- Last update: 2010/03/12
//-------------------------------------------------------------------------------
//-- Description: This performs the butterfly with v shift left 4 times
//-- Datapath for butterfly and reduction
//--
//-------------------------------------------------------------------------------
//-- Revisions  : 1
//-- Date        Version  Author  	Description
//-- 2010/03/12  1.0      Sinan Huang  
//-------------------------------------------------------------------------------

`timescale 1ns/1ps
module butterfly2r(ai, 
				   bi, 
				   ao, 
				   bo
				   );
	//input
	input signed [14:0] ai;
	input signed [14:0] bi;	
	
	//output
	output signed [14:0] ao;
	output signed [14:0] bo;	
	
	wire signed [16:0] buffer;
	assign ao = ai + bi;
	assign buffer = ((ai-bi) << 4);
	do_reduce bufReduce(buffer, bo);
	
endmodule 