//-- Copyright (C) 2009 SES Lab and PAC Lab @VT
//--
//-- This program is free software; you can redistribute it and/or
//-- modify it under the terms of the GNU General Public License as
//-- published by the Free Software Foundation; either version 2 of the
//-- License, or (at your option) any later version.
//--
//-- This program is distributed in the hope that it will be useful,
//-- but WITHOUT ANY WARRANTY; without even the implied warranty of
//-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//-- GNU General Public License for more details.
//-------------------------------------------------------------------------------
//-- Title      : Reduce module
//-- Project    : SHA3
//-------------------------------------------------------------------------------
//-- File       : do_reduce.v
//-- Author     : Sinan Huang, Eric Guo
//-- Company    : PAC & SES @VT
//-- Last update: 2010/03/12
//-------------------------------------------------------------------------------
//-- Description: This performs the reduce
//-- Datapath for reduce
//--
//-------------------------------------------------------------------------------
//-- Revisions  : 1
//-- Date        Version  Author  	Description
//-- 2010/03/12  1.0      Sinan Huang  
//-------------------------------------------------------------------------------

`timescale 1ns/1ps
module do_reduce(ai, 
				 ao);
	//input
	input signed [16:0] ai;
	
	//output
	output signed [14:0] ao;
	
	wire signed [9:0] diff;
	wire signed [9:0] High8;
	wire signed [9:0] Low8;
	assign High8 = {ai[16],ai[16:8]};
	assign Low8 = {2'b0, ai[7:0]};
	assign diff = Low8 - High8;
	assign ao = {{5{diff[9]}},diff};
endmodule