//-- Copyright (C) 2009 SES Lab and PAC Lab @VT
//--
//-- This program is free software; you can redistribute it and/or
//-- modify it under the terms of the GNU General Public License as
//-- published by the Free Software Foundation; either version 2 of the
//-- License, or (at your option) any later version.
//--
//-- This program is distributed in the hope that it will be useful,
//-- but WITHOUT ANY WARRANTY; without even the implied warranty of
//-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//-- GNU General Public License for more details.
//-------------------------------------------------------------------------------
//-- Title      : Full Reduce module
//-- Project    : SHA3
//-------------------------------------------------------------------------------
//-- File       : do_reduce_full.v
//-- Author     : Sinan Huang, Eric Guo
//-- Company    : PAC & SES @VT
//-- Last update: 2010/03/12
//-------------------------------------------------------------------------------
//-- Description: This performs the full reduce
//-- Datapath for full reduce
//--
//-------------------------------------------------------------------------------
//-- Revisions  : 1
//-- Date        Version  Author  	Description
//-- 2010/03/12  1.0      Sinan Huang  
//-------------------------------------------------------------------------------

`timescale 1ns/1ps
module do_reduce_full(ai, 
					  ao
					  );
	//input
	input signed [14:0] ai;
	
	//output
	output signed [8:0] ao;
	
	
	wire signed [14:0] reduce_out;
	wire signed [9:0] diff;
	do_reduce full_do_reduce({{2{ai[14]}},ai},reduce_out);
	assign diff = reduce_out - 257;		
	assign ao = (reduce_out <= 128) ? reduce_out : diff;	
endmodule 